com.fasterxml.jackson.databind.type

## Class SimpleType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.SimpleType

All Implemented Interfaces:
  JsonSerializable, Serializable, Type

    public final class SimpleType
    extends TypeBase

Simple types are defined as anything other than one of recognized container types (arrays, Collections, Maps). For our needs we need not know anything further, since we have no way of dealing with generic types other than Collections and Maps.

See Also:
  Serialized Form

### Field Summary

Fields
`protected String[]` `_typeNames` Names of generic type arguments for this type; will match values in `_typeParameters`
`protected JavaType[]` `_typeParameters` Generic type arguments for this type.

### Fields inherited from class com.fasterxml.jackson.databind.JavaType

`_asStatic, _class, _hash, _typeHandler, _valueHandler`

### Constructor Summary

Constructors
`protected` `SimpleType(Class<?> cls)`
`protected` `SimpleType(Class<?> cls, String[] typeNames, JavaType[] typeParams, Object valueHandler, Object typeHandler, boolean asStatic)`

### Method Summary

Methods
`protected JavaType` `_narrow(Class<?> subclass)`
`protected String` `buildCanonicalName()`
`static SimpleType` `construct(Class<?> cls)`
`static SimpleType` `constructUnsafe(Class<?> raw)` Method used by core Jackson classes: NOT to be used by application code.
`JavaType` `containedType(int index)`
`int` `containedTypeCount()`
`String` `containedTypeName(int index)`
`boolean` `equals(Object o)`
`StringBuilder` `getErasedSignature(StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
`StringBuilder` `getGenericSignature(StringBuilder sb)`
`boolean` `isContainerType()`
`JavaType` `narrowContentsBy(Class<?> subclass)`
`String` `toString()`
`JavaType` `widenContentsBy(Class<?> subclass)`
`JavaType` `withContentTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that its content type will have specified type handler assigned.
`SimpleType` `withContentValueHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
`SimpleType` `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
`SimpleType` `withTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
`SimpleType` `withValueHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_classSignature, getTypeHandler, getValueHandler, serialize, serializeWithType, toCanonical`

### Methods inherited from class com.fasterxml.jackson.databind.JavaType

`_assertSubclass, _widen, forcedNarrowBy, getContentType, getErasedSignature, getGenericSignature, getKeyType, getRawClass, hasGenericTypes, hashCode, hasRawClass, isAbstract, isArrayType, isCollectionLikeType, isConcrete, isEnumType, isFinal, isInterface, isMapLikeType, isPrimitive, isThrowable, narrowBy, useStaticType, widenBy`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### _typeParameters

    protected final JavaType[] _typeParameters

Generic type arguments for this type.

#### _typeNames

    protected final String[] _typeNames

Names of generic type arguments for this type; will match values in `_typeParameters`

### Constructor Detail

#### SimpleType

    protected SimpleType(Class<?> cls)

#### SimpleType

    protected SimpleType(Class<?> cls,
              String[] typeNames,
              JavaType[] typeParams,
              Object valueHandler,
              Object typeHandler,
              boolean asStatic)

### Method Detail

#### constructUnsafe

    public static SimpleType constructUnsafe(Class<?> raw)

Method used by core Jackson classes: NOT to be used by application code.

NOTE: public only because it is called by `ObjectMapper` which is not in same package

#### _narrow

    protected JavaType _narrow(Class<?> subclass)

Specified by:
  `_narrow` in class `JavaType`

#### narrowContentsBy

    public JavaType narrowContentsBy(Class<?> subclass)

Specified by:
  `narrowContentsBy` in class `JavaType`

#### widenContentsBy

    public JavaType widenContentsBy(Class<?> subclass)

Specified by:
  `widenContentsBy` in class `JavaType`

#### construct

    public static SimpleType construct(Class<?> cls)

#### withTypeHandler

    public SimpleType withTypeHandler(Object h)

Description copied from class: `JavaType`
"Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.

Specified by:
  `withTypeHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentTypeHandler

    public JavaType withContentTypeHandler(Object h)

Description copied from class: `JavaType`
"Copy method" that will construct a new instance that is identical to this instance, except that its content type will have specified type handler assigned.

Specified by:
  `withContentTypeHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withValueHandler

    public SimpleType withValueHandler(Object h)

Description copied from class: `JavaType`
"Copy method" that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

Specified by:
  `withValueHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentValueHandler

    public SimpleType withContentValueHandler(Object h)

Description copied from class: `JavaType`
"Copy method" that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.

Specified by:
  `withContentValueHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withStaticTyping

    public SimpleType withStaticTyping()

Description copied from class: `JavaType`
Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).

Specified by:
  `withStaticTyping` in class `JavaType`

#### buildCanonicalName

    protected String buildCanonicalName()

Specified by:
  `buildCanonicalName` in class `TypeBase`

#### isContainerType

    public boolean isContainerType()

Specified by:
  `isContainerType` in class `JavaType`
Returns:
  True if type represented is a container type; this includes array, Map and Collection types.

#### containedTypeCount

    public int containedTypeCount()

Overrides:
  `containedTypeCount` in class `JavaType`

#### containedType

    public JavaType containedType(int index)

Overrides:
  `containedType` in class `JavaType`

#### containedTypeName

    public String containedTypeName(int index)

Overrides:
  `containedTypeName` in class `JavaType`

#### getErasedSignature

    public StringBuilder getErasedSignature(StringBuilder sb)

Description copied from class: `JavaType`
Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.

Specified by:
  `getErasedSignature` in class `TypeBase`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### getGenericSignature

    public StringBuilder getGenericSignature(StringBuilder sb)

Specified by:
  `getGenericSignature` in class `TypeBase`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### toString

    public String toString()

Specified by:
  `toString` in class `JavaType`

#### equals

    public boolean equals(Object o)

Specified by:
  `equals` in class `JavaType`